package com.cardiff.client_project.constant;

public enum ResponseCode {
    PASSWORD_ERROR(0,"password error"),
    USERNAME_ERROR(0,"username error"),
    ERROR(0,"fail"),
    SUCCESS(1,"success"),
    DATA_ERROR(0,"Parameter exception"),
    NO_RESPONSE_DATA(0,"Nonresponse data"),
    CHECK_CODE_NOT_EMPTY(0,"The verification code cannot be empty"),
    CHECK_CODE_ERROR(0,"Verification code error"),
    USERNAME_OR_PASSWORD_ERROR(0,"The user name or password is incorrect"),
    ACCOUNT_EXISTS_ERROR(0,"The account already exists"),
    ACCOUNT_NOT_EXISTS(0,"The account does not exist"),
    TOKEN_ERROR(2,"User is not logged in, please log in first"),
    NOT_PERMISSION(3,"No permission to access the resource"),
    ANONMOUSE_NOT_PERMISSION(0,"Anonymous users do not have access");

    private int code;
    private String message;

    ResponseCode(int code, String message) {
        this.code = code;
        this.message = message;
    }

    public int getCode() {
        return code;
    }

    public String getMessage() {
        return message;
    }
}
