package com.cardiff.client_project.service;

import com.cardiff.client_project.mapper.SuperAdminMapper;
import com.cardiff.client_project.pojo.entity.CommonAdmin;
import com.cardiff.client_project.mapper.HospitalAdminMapper;
import com.cardiff.client_project.pojo.entity.Hospital;
import com.cardiff.client_project.pojo.entity.HospitalUser;
import com.cardiff.client_project.pojo.entity.Patient;
import com.cardiff.client_project.pojo.entity.SuperUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

@Service
public class UserLogin implements UserDetailsService {

    @Autowired
    SuperAdminMapper superAdminMapper;
    @Autowired
    HospitalAdminMapper hospitalAdminMapper;

    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        UserDetails userDetails = null;
        System.out.println(username);
        Object object = superAdminMapper.getInforByName(username);


        if(object instanceof SuperUser){
            SuperUser inforByName = (SuperUser) object;
            String type = superAdminMapper.getTypeById(inforByName.getRoleId());
            SimpleGrantedAuthority authority = new SimpleGrantedAuthority(type);
            userDetails = User.withUsername(inforByName.getName()).password(inforByName.getPassword()).authorities(authority).build();
        }
        if(object instanceof CommonAdmin){
            CommonAdmin inforByName = (CommonAdmin) object;
            if(inforByName.getStatus()==0){
                return User.withUsername(inforByName.getName()).password(inforByName.getPassword()).authorities(new SimpleGrantedAuthority("NULL")).build();
            }
            String type = superAdminMapper.getTypeById(inforByName.getRoleId());
            SimpleGrantedAuthority authority = new SimpleGrantedAuthority(type);
            userDetails = User.withUsername(inforByName.getName()).password(inforByName.getPassword()).authorities(authority).build();
        }

        if(object instanceof HospitalUser){
            HospitalUser inforByName = (HospitalUser) object;
            String type = hospitalAdminMapper.getTypeById(inforByName.getRoleId());
            SimpleGrantedAuthority authority = new SimpleGrantedAuthority(type);
            userDetails = User.withUsername(inforByName.getName()).password(inforByName.getPassword()).authorities(authority).build();
        }

        if(object instanceof Hospital){
            Hospital inforByName = (Hospital) object;
            if(inforByName.getStatus()==0){
                return User.withUsername(inforByName.getName()).password(inforByName.getPassword()).authorities(new SimpleGrantedAuthority("NULL")).build();
            }
            String type = hospitalAdminMapper.getTypeById(inforByName.getRoleId());
            SimpleGrantedAuthority authority = new SimpleGrantedAuthority(type);
            userDetails = User.withUsername(inforByName.getName()).password(inforByName.getPassword()).authorities(authority).build();
        }

        if(object instanceof Patient){
            Patient inforByName = (Patient) object;
            if(inforByName.getStatus()==0){
                return User.withUsername(inforByName.getName()).password(inforByName.getPassword()).authorities(new SimpleGrantedAuthority("NULL")).build();
            }
            String type = superAdminMapper.getTypeById(inforByName.getRoleId());
            SimpleGrantedAuthority authority = new SimpleGrantedAuthority(type);
            userDetails = User.withUsername(inforByName.getName()).password(inforByName.getPassword()).authorities(authority).build();
        }
        return userDetails;
    }


}   